{ -----------------------------------------------------------------  }
{ CallFrm
  Author:              Peter Zwosta
  Homepage: http://home.t-online.de/home/Peter.Zwosta                }
{ -----------------------------------------------------------------  }
{ sample for TCapiMonitor.                                           }
{ -----------------------------------------------------------------  }
{ History
  Oct 9, 1999 added reject options and support for
          CapiMonitor1RejectCallQuestion, added lblDisconnectInfo
          to show the disconnect information provided by
          CapiMonitor1DisconnectInfo 
  Nov 1, 1998 added Reset-Checkbox, to call Reset in
          CapiAnruMonitor1DoResetCapi
{ -----------------------------------------------------------------  }
unit CallFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, ComCtrls, CpMoni, CpConst;

type
  TForm1 = class(TForm)
    lblCallingPartyNumber: TLabel;
    Label2: TLabel;
    cmdQuit: TButton;
    Label1: TLabel;
    lblCipValue: TLabel;
    Label3: TLabel;
    lblTime: TLabel;
    lblCalledPartyNumber: TLabel;
    Label5: TLabel;
    Bevel1: TBevel;
    pmUserBusy: TMenuItem;
    pmIncompDestination: TMenuItem;
    pmIgnoreCall: TMenuItem;
    pmNormalClear: TMenuItem;
    paStatus: TPanel;
    cbRejectCalls: TCheckBox;
    N1: TMenuItem;
    pmClearCall: TMenuItem;
    cbResetAfterCall: TCheckBox;
    cmdCall: TButton;
    popupCall: TPopupMenu;
    rbRejectAnyCall: TRadioButton;
    rbRejectCallsFromNumber: TRadioButton;
    edCallingNumberToReject: TEdit;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    lblDisconnectInfo: TLabel;
    CapiMonitor1: TCapiMonitor;
    procedure cmdQuitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PopUpMenu1Clicked(Sender: TObject);
    procedure cmdCallClick(Sender: TObject);
    procedure CapiMonitor1StateChange(bUserCanReject: Boolean;
                                      bUserCanCangeNoDisturbMode : boolean);
    procedure cbRejectCallsClick(Sender: TObject);
    procedure CapiMonitor1DoResetCapi(Sender: TObject);
    procedure CapiMonitor1IncomingCall(CallingPartyNumber,
      CalledPartyNumber: String; CipValue: Word; CipValueString: String);
    procedure CapiMonitor1RejectCallQuestion(CallingPartyNumber,
      CalledPartyNumber: String; CipValue: Word; var aRejectCause: Word);
    procedure CapiMonitor1DisconnectInfo(aRejectCause,
      aDisconnectReason: Word);
  end;

var
  Form1: TForm1;

implementation

var Controller    : dWord;
    RejectTimeOut : integer;

{$R *.DFM}

{ -------------------------------------------------------------------}
{ RejectStringFromCause                                              }
{ -------------------------------------------------------------------}
function RejectStringFromCause(aRejectCause : word) : string;
var RejectString : string;
begin
  RejectString := '';
  { !!! see the comments for the method RejectCall in CpMoni.pas }
  case aRejectCause of
    rjeAcceptCall  : RejectString := 'call rejected - caller is charged';
    rjeIgnoreCall  : RejectString := 'call ignored';
    rjeUserBusy    : RejectString := 'user busy sent';
    rjeIncompDest  : RejectString := 'incompatible destination sent';
    rjeNormalClear : RejectString := '"no answer" sent';
    rjeUndefined   : RejectString := 'not rejected';
  end;
  RejectStringFromCause := RejectString;
end;
{ -------------------------------------------------------------------}
{ TForm1.cmdQuitClick                                                }
{ -------------------------------------------------------------------}
procedure TForm1.cmdQuitClick(Sender: TObject);
begin
  Close;
end;
{ -------------------------------------------------------------------}
{ TForm1.FormCreate                                                  }
{ -------------------------------------------------------------------}
procedure TForm1.FormCreate(Sender: TObject);
begin
  Controller    := 1;
  RejectTimeOut := 10;

  { 10 sec. time for the user for an adequate reaction on an
    incoming call. After 10 sec. a CONNECT is refused automatically.
    Other ISDN devices still can accept the call.
    !!! See comments in CPMONI.PAS concerning WaitForCall            }
  CapiMonitor1.WaitForCall(Controller, RejectTimeOut);
  paStatus.Caption := ' Status: ' + CapiMonitor1.ErrorString;

  cbRejectCallsClick(self);
end;
{ -------------------------------------------------------------------}
{ TForm1.CapiMonitor1RejectCallQuestion
  This event is sent by TCapiMonitor to enable the app. to reject
  an incoming call immediately without having to ask the user        }
{ -------------------------------------------------------------------}
procedure TForm1.CapiMonitor1RejectCallQuestion(CallingPartyNumber,
                                   CalledPartyNumber: String;
                                   CipValue: Word;
                                   var aRejectCause: Word);
begin
  { Accept the call (aRejectCause := rjeAcceptCall) means to accept
    the call and hang up immediately to be sure the caller has no
    chance to disturb - the caller is charged !!! }
  if cbRejectCalls.checked and
     rbRejectCallsFromNumber.checked and
     (CallingPartyNumber = edCallingNumberToReject.text) then begin
    aRejectCause := rjeAcceptCall;
  end;

  { To Reject any call you could use the following code instead of
    setting CapiMonitor1.NoDisturbMode in TForm1.cbRejectCallsClick }
  {
  if (cbRejectCalls.enabled and cbRejectCalls.checked and
       rbRejectAnyCall.checked)
    then aRejectCause := rjeAcceptCall;
  }
end;
{ -------------------------------------------------------------------}
{ TForm1.CapiMonitor1IncomingCall                                    }
{ -------------------------------------------------------------------}
procedure TForm1.CapiMonitor1IncomingCall(CallingPartyNumber,
                                   CalledPartyNumber: String;
                                   CipValue: Word;
                                   CipValueString: String);
begin
  lblTime.Caption := TimeToStr(Time);
  if CallingPartyNumber <> ''
    then lblCallingPartyNumber.Caption := CallingPartyNumber
    else lblCallingPartyNumber.Caption := 'unknown';
  lblCalledPartyNumber.Caption := CalledPartyNumber;
  lblCipValue.Caption :=  CipValueString + ' (' + IntToStr(CipValue) + ')';

  paStatus.Caption := ' Status: Incoming call';

  { if the app. is minimized show the calling party number as
    app. title on the windows taskbar } 
  if IsIconic(Application.Handle) and (CallingPartyNumber <> '')
      then Application.Title := CallingPartyNumber;
end;
{ -------------------------------------------------------------------}
{ TForm1.CapiMonitor1RejectStateChange
  The call monitor component fires an event wenn the user is given
  the possibility to react upon an incoming call.                        }
{ -------------------------------------------------------------------}
procedure TForm1.CapiMonitor1StateChange(bUserCanReject: Boolean;
                                         bUserCanCangeNoDisturbMode : boolean);
var i : integer;
begin
  cmdCall.Enabled := bUserCanReject;
  cbRejectCalls.Enabled := bUserCanCangeNoDisturbMode;
  cbRejectCallsClick(self);
  { disable menus }
  For i := 0 to popupCall.Items.Count - 1 do
    popupCall.Items[i].Enabled := bUserCanReject;
  paStatus.Caption := ' Status: ' + CapiMonitor1.ErrorString;
end;
{ -------------------------------------------------------------------}
{ TForm1.CapiMonitor1DisconnectInfo                                  }
{ -------------------------------------------------------------------}
procedure TForm1.CapiMonitor1DisconnectInfo(aRejectCause,
  aDisconnectReason: Word);
begin
  if (aRejectCause <> rjeUndefined) then begin
    lblDisconnectInfo.Caption := RejectStringFromCause(aRejectCause)
  end else begin
    lblDisconnectInfo.Caption := CapiGetInfoString(aDisconnectReason);
  end;
end;
{ -------------------------------------------------------------------}
{ TForm1.CapiMonitor1DoResetCapi                                     }
{ -------------------------------------------------------------------}
procedure TForm1.CapiMonitor1DoResetCapi(Sender: TObject);
begin
  if cbResetAfterCall.Checked then begin
    if CapiMonitor1.ResetCapi then begin
      CapiMonitor1.WaitForCall(Controller, RejectTimeOut);
      paStatus.Caption := ' Status: ' + CapiMonitor1.ErrorString;
    end else
       { 'Reset not successful' }
      MessageDlg('Error during reset.', mtError, [mbOK], 0);
  end;
end;
{ -------------------------------------------------------------------}
{ TForm1.PopUpMenu1Clicked
  Answers the call (see CpConst.pas for usage of consts)             }
{ -------------------------------------------------------------------}
procedure TForm1.PopUpMenu1Clicked(Sender: TObject);
var aRejectCause : word;
begin
  { if meanwhile the button was disabled then exit }
  if not cmdCall.Enabled then exit;

  aRejectCause := rjeUndefined;
  if Sender = pmIgnoreCall then aRejectCause := rjeIgnoreCall;
  if Sender = pmNormalClear then aRejectCause := rjeNormalClear;
  if Sender = pmUserBusy then aRejectCause := rjeUserBusy;
  if Sender = pmIncompDestination then aRejectCause := rjeIncompDest;
  { to accept the call means to accept and immediately hang up -
    the caller is charged }
  if Sender = pmClearCall then aRejectCause := rjeAcceptCall;

  if (aRejectCause <> rjeUndefined) then begin
    CapiMonitor1.RejectCall(aRejectCause);
  end;
end;
{ -------------------------------------------------------------------}
{ TForm1.cmdCallClick
  Shows popup menu when button is clicked                            }
{ -------------------------------------------------------------------}
procedure TForm1.cmdCallClick(Sender: TObject);
begin
  popupCall.PopUp(cmdCall.ClientOrigin.x + cmdCall.Width,
                  cmdCall.ClientOrigin.y);
end;
{ -------------------------------------------------------------------}
{ TForm1.cbNoDisturbClick
  Switches between NoDisturbMode true and false
  CapiMonitor.OnStateChange determins whether the user is allowed
  to switch (see TForm1.CapiMonitor1StateChange)                     }
{ -------------------------------------------------------------------}
procedure TForm1.cbRejectCallsClick(Sender: TObject);
begin
  rbRejectAnyCall.enabled := cbRejectCalls.enabled and cbRejectCalls.checked;
  rbRejectCallsFromNumber.enabled := cbRejectCalls.enabled and cbRejectCalls.checked;
  edCallingNumberToReject.ReadOnly := (not cbRejectCalls.enabled) or (not cbRejectCalls.checked);
  if edCallingNumberToReject.ReadOnly
    then edCallingNumberToReject.Color := clBtnFace
    else edCallingNumberToReject.Color := clWindow;

  { To reject any calls you can use CapiMonitor1.NoDisturbMode. You
    could also use CapiMonitor1RejectCallQuestion to set aRejectCause
    to rjeAcceptCall ignoring the calling party number } 
  if cbRejectCalls.enabled then
    CapiMonitor1.NoDisturbMode :=
        cbRejectCalls.checked and rbRejectAnyCall.checked;
end;
end.
