{ -----------------------------------------------------------------  }
{ CapiIFrm
  Author:              Peter Zwosta
  Homepage: http://home.t-online.de/home/Peter.Zwosta                }
{ -----------------------------------------------------------------  }
{ sample for TCapiInfo.                                              }
{ -----------------------------------------------------------------  }
unit CapiIFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CpConst, CpInfo, CpHand, cpDll, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    lblNrOfControllers: TLabel;
    lblwRes: TLabel;
    Bevel1: TBevel;
    cmdBeenden: TButton;
    Label2: TLabel;
    cmbControllers: TComboBox;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Bevel3: TBevel;
    lblManufacturer: TLabel;
    Bevel5: TBevel;
    lblSerialNr: TLabel;
    lblVersion: TLabel;
    Bevel6: TBevel;
    Label3: TLabel;
    lblBChannels: TLabel;
    lblGlobalOptions: TLabel;
    lsB3ProtocolSupport: TListBox;
    lsB2ProtocolSupport: TListBox;
    lsB1ProtocolSupport: TListBox;
    lblB1ProtocolSupport: TLabel;
    lblB2ProtocolSupport: TLabel;
    lblB3ProtocolSupport: TLabel;
    lsGlobalOptions: TListBox;
    TabSheet6: TTabSheet;
    lsSupplementaryServices: TListBox;
    lblSupplementaryServices: TLabel;
    CapiInfo: TCapiInfo;
    procedure FormCreate(Sender: TObject);
    procedure cmdBeendenClick(Sender: TObject);
    procedure cmbControllersChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure CapiInfoSuppServInfoAvailable(Sender: TObject);
  private
    { Private-Deklarationen }
    Procedure ClearLabels(aClearInfoLabels : boolean);
    procedure InvokeCapiInfo;
    Procedure GetProfile(aController : dword);
    Procedure GetCapiInfos;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
{ -------------------------------------------------------------------}
{ FormCreate                                                         }
{ -------------------------------------------------------------------}
procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.Title := 'CapiInfo';
  ClearLabels(true);                           { clear all labels }
  cmbControllers.enabled := false;
  PageControl1.ActivePage := TabSheet1;
end;
{ -------------------------------------------------------------------}
{ FormActivate                                                       }
{ -------------------------------------------------------------------}
procedure TForm1.FormActivate(Sender: TObject);
begin
  InvokeCapiInfo;
end;
{ -------------------------------------------------------------------}
{ cmbControllersChange                                               }
{ -------------------------------------------------------------------}
procedure TForm1.cmbControllersChange(Sender: TObject);
begin
  GetProfile(cmbControllers.ItemIndex + 1);
end;
{ -------------------------------------------------------------------}
{ cmdBeendenClick                                                    }
{ -------------------------------------------------------------------}
procedure TForm1.cmdBeendenClick(Sender: TObject);
begin
  Close;
end;
{ -------------------------------------------------------------------}
{ TForm1.InvokeCapiInfo                                              }
{ -------------------------------------------------------------------}
procedure TForm1.InvokeCapiInfo;
var i : integer;
    NrOfControllers : word;
begin
  lblwRes.Caption := CapiInfo.ErrorString;
  if (CapiInfo.Error = 0) then begin
    GetCapiInfos;                 { set controller independant labels }
    NrOfControllers := CapiInfo.NrOfControllers;
    For i := 1 to NrOfControllers do begin
      cmbControllers.Items.Add('Profile for Controller ' + IntToStr(i));
    end;
    if (CapiInfo.NrOfControllers > 0) then begin
      cmbControllers.enabled := true;
      cmbControllers.ItemIndex := 0;
      GetProfile(1);
    end;
  end;
end;
{ -------------------------------------------------------------------}
{ GetCapiInfos
  sets the controller independant labels                             }
{ -------------------------------------------------------------------}
Procedure TForm1.GetCapiInfos;
begin
  lblNrOfControllers.Caption := IntToStr(CapiInfo.NrOfControllers);
  lblManufacturer.Caption := CapiInfo.Manufacturer;
  lblVersion.Caption := CapiInfo.Version;
  lblSerialNr.Caption := CapiInfo.SerialNumber;
end;
{ -------------------------------------------------------------------}
{ GetProfile
  Get controller dependant information. If controller changes in the
  combobox this method is called again.                              }
{ -------------------------------------------------------------------}
Procedure TForm1.GetProfile(aController : dword);
var aStrList : TStringList;
    i : integer;
begin
  ClearLabels(false);          { clear controller independant labels }
  CapiInfo.Controller  := aController;          { set new controller }
  lblwRes.Caption := CapiInfo.ErrorString;
  if CapiInfo.Error <> 0 then exit;

  { number fo supported B channels }
  lblBChannels.Caption := IntToStr(CapiInfo.NrOfSupportedBChannels);

  lsGlobalOptions.Items.Clear;                     { clear listboxes }
  lsB1ProtocolSupport.Items.Clear;
  lsB2ProtocolSupport.Items.Clear;
  lsB3ProtocolSupport.Items.Clear;
  lsSupplementaryServices.Items.Clear;

  { stringlist used to fill listboxes }
  aStrList := TStringList.Create;

  { global Options }
  lblGlobalOptions.Caption := '$' + IntToHex(CapiInfo.GlobalOptions, 4);
  CapiInfo.GlobalOptionsAsStrings(aStrList);
  For i := 0 to aStrList.Count - 1 do lsGlobalOptions.Items.Add(aStrList[i]);

  { B1ProtocolSupport }
  aStrList.Clear;
  lblB1ProtocolSupport.Caption := '$' + IntToHex(CapiInfo.B1ProtocolSupport, 4);
  CapiInfo.B1ProtocolSupportAsStrings(aStrList);
  For i := 0 to aStrList.Count - 1 do lsB1ProtocolSupport.Items.Add(aStrList[i]);

  { B2ProtocolSupport }
  aStrList.Clear;
  lblB2ProtocolSupport.Caption := '$' + IntToHex(CapiInfo.B2ProtocolSupport, 4);
  CapiInfo.B2ProtocolSupportAsStrings(aStrList);
  For i := 0 to aStrList.Count - 1 do lsB2ProtocolSupport.Items.Add(aStrList[i]);

  { B3ProtocolSupport }
  aStrList.Clear;
  lblB3ProtocolSupport.Caption := '$' + IntToHex(CapiInfo.B3ProtocolSupport, 4);
  CapiInfo.B3ProtocolSupportAsStrings(aStrList);
  For i := 0 to aStrList.Count - 1 do lsB3ProtocolSupport.Items.Add(aStrList[i]);

  aStrList.Free;
end;
{ -------------------------------------------------------------------}
{ TForm1.CapiInfoSuppServInfoAvailable
  This kind of information is only available by sending a
  FACILITY_REQ to CAPI. The corresponding FACILITY_CONF contains
  the desired information. This event is sent from TCapiInfo when
  FACILITY_CONF is sent by CAPI.                                     }
{ -------------------------------------------------------------------}
procedure TForm1.CapiInfoSuppServInfoAvailable(Sender: TObject);
var aStrList : TStringList;
    i : integer;
begin
  aStrList := TStringList.Create;                { used in listboxes }
  { Supplementary Services }
  aStrList.Clear;
  lblSupplementaryServices.Caption := '$' + IntToHex(CapiInfo.SupplementaryServices, 4);
  CapiInfo.SupplementaryServicesAsStrings(aStrList);
  For i := 0 to aStrList.Count - 1 do lsSupplementaryServices.Items.Add(aStrList[i]);
  aStrList.Free;
end;
{ -------------------------------------------------------------------}
{ ClearLabels
  false means, that controller independant labels aren't deleted
  (see GetProfile)                                                   }
{ -------------------------------------------------------------------}
Procedure TForm1.ClearLabels(aClearInfoLabels : boolean);
begin
  if aClearInfoLabels then begin
    lblNrOfControllers.Caption := '';
    lblManufacturer.Caption := '';
    lblSerialNr.Caption := '';
    lblVersion.Caption := '';
  end;

  lblBChannels.Caption := '';
  lblGlobalOptions.Caption := '';
  lblB1ProtocolSupport.Caption := '';
  lblB2ProtocolSupport.Caption := '';
  lblB3ProtocolSupport.Caption := '';
  lblSupplementaryServices.Caption := '';
  lsGlobalOptions.Items.Clear;
  lsB1ProtocolSupport.Items.Clear;
  lsB2ProtocolSupport.Items.Clear;
  lsB3ProtocolSupport.Items.Clear;
  lblwRes.Caption := '';
end;
end.
